## tzpfms 0.1.0

=== Makefile ===
# The MIT License (MIT)

# Copyright (c) 2020 наб <nabijaczleweli@nabijaczleweli.xyz>

# Permission is hereby granted, free of charge, to any person obtaining a copy of
# this software and associated documentation files (the "Software"), to deal in
# the Software without restriction, including without limitation the rights to
# use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
# the Software, and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:

# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.

# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
# COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
# IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


include configMakefile


LDDLLS := rt tspi $(OS_LD_LIBS)
PKGS := libzfs libzfs_core tss2-esys tss2-rc
LDAR := $(LNCXXAR) $(foreach l,,-L$(BLDDIR)$(l)) $(foreach dll,$(LDDLLS),-l$(dll)) $(shell pkg-config --libs $(PKGS))
INCAR := $(foreach l,$(foreach l,,$(l)/include),-isystemext/$(l)) $(foreach l,,-isystem$(BLDDIR)$(l)/include) $(shell pkg-config --cflags $(PKGS))
VERAR := $(foreach l,TZPFMS,-D$(l)_VERSION='$($(l)_VERSION)')
BINARY_SOURCES := $(sort $(wildcard $(SRCDIR)bin/*.cpp $(SRCDIR)bin/**/*.cpp))
COMMON_SOURCES := $(filter-out $(BINARY_SOURCES),$(sort $(wildcard $(SRCDIR)*.cpp $(SRCDIR)**/*.cpp $(SRCDIR)**/**/*.cpp $(SRCDIR)**/**/**/*.cpp)))
MANPAGE_HEADERS := $(sort $(wildcard $(MANDIR)*.h))
MANPAGE_SOURCES := $(sort $(wildcard $(MANDIR)*.md.pp))
INITRD_HEADERS := $(sort $(wildcard $(INITRDDIR)*.h))


.PHONY : all clean build shellcheck i-t dracut man
.SECONDARY:


all : build man shellcheck i-t dracut

shellcheck : i-t dracut
	find $(OUTDIR)initramfs-tools/ $(OUTDIR)dracut -name '*.sh' -exec echo $(SHELLCHECK) --exclude SC1091 {} + | sh -x

clean :
	rm -rf $(OUTDIR)

build : $(subst $(SRCDIR)bin/,$(OUTDIR),$(subst .cpp,$(EXE),$(BINARY_SOURCES)))
man : $(OUTDIR)man/index.txt
i-t : $(OUTDIR)initramfs-tools/usr/share/initramfs-tools/hooks/tzpfms $(OUTDIR)initramfs-tools/usr/share/tzpfms/initramfs-tools-zfs-patch.sh
dracut : $(patsubst $(INITRDDIR)dracut/%,$(OUTDIR)dracut/usr/lib/dracut/modules.d/91tzpfms/%,$(sort $(wildcard $(INITRDDIR)dracut/*.sh)))


$(OUTDIR)man/index.txt : $(MANDIR)index.txt $(patsubst $(MANDIR)%.pp,$(OUTDIR)man/%,$(MANPAGE_SOURCES))
	@mkdir -p $(dir $@)
	cp $< $(dir $@)
	$(RONN) --organization="tzpfms developers"    $(filter-out $<,$^)
	$(RONN) --organization="tzpfms developers" -f $(filter-out $<,$^)

$(OUTDIR)initramfs-tools/usr/share/initramfs-tools/hooks/tzpfms: $(INITRDDIR)initramfs-tools/hook $(INITRD_HEADERS)
	@mkdir -p $(dir $@)
	$(AWK) -f pp.awk $< > $@
	chmod --reference $< $@

$(OUTDIR)initramfs-tools/usr/share/tzpfms/initramfs-tools-zfs-patch.sh: $(INITRDDIR)initramfs-tools/zfs-patch.sh $(INITRD_HEADERS)
	@mkdir -p $(dir $@)
	$(AWK) -f pp.awk $< > $@
	chmod --reference $< $@


$(OUTDIR)%$(EXE) : $(subst $(SRCDIR),$(OBJDIR),$(subst .cpp,$(OBJ),$(SRCDIR)bin/%.cpp $(COMMON_SOURCES)))
	@mkdir -p $(dir $@)
	$(CXX) $(CXXAR) -o$@ $^ $(PIC) -Wl,--as-needed $(LDAR)
	$(STRIP) $(STRIPAR) $@

$(OBJDIR)%$(OBJ) : $(SRCDIR)%.cpp
	@mkdir -p $(dir $@)
	$(CXX) $(CXXAR) $(INCAR) $(VERAR) -c -o$@ $^

$(BLDDIR)test/%$(OBJ) : $(TSTDIR)%.cpp
	@mkdir -p $(dir $@)
	$(CXX) $(CXXAR) $(INCAR) -I$(SRCDIR) $(VERAR) -c -o$@ $^

$(OUTDIR)man/%.md : $(MANDIR)%.md.pp $(MANPAGE_HEADERS)
	@mkdir -p $(dir $@)
	$(AWK) -f pp.awk $< > $@

$(OUTDIR)dracut/usr/lib/dracut/modules.d/91tzpfms/% : $(INITRDDIR)dracut/% $(INITRD_HEADERS)
	@mkdir -p $(dir $@)
	$(AWK) -f pp.awk $< > $@
	chmod --reference $< $@

=== debian/changelog ===
tzpfms (0.1.0-1) unstable; urgency=medium

  * Initial packaging, upstream version 0.1.0

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Tue, 08 Dec 2020 18:35:44 +0100

=== debian/rules ===
#!/usr/bin/make -f


include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

CXX := $(CXX) $(subst -O2,,$(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get LDFLAGS))
TEMPDIR = $(CURDIR)/debian/tmp/
VERSION = $(shell awk '/^version/ {print $$3}' Cargo.toml | sed 's/"//g')


override_dh_auto_build:
	mkdir -p $(TEMPDIR)
	localedef -i en_GB -c -f UTF-8 -A /usr/share/locale/locale.alias $(TEMPDIR)en_GB.UTF-8
	LOCPATH="$(TEMPDIR)" LC_CTYPE="en_GB.UTF-8" $(MAKE) STRIP="@echo > /dev/null" CXX="$(CXX)"

override_dh_auto_clean:
	$(MAKE) clean

override_dh_auto_install:
	dh_install

override_dh_installchangelogs:
	dh_installchangelogs debian/changelog.upstream

override_dh_installdocs:
	dh_installdocs $(wildcard TODO) README.md

%:
	dh $@

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/tzpfms-$1\.tar\.gz/ \
  https://git.sr.ht/~nabijaczleweli/tzpfms/refs .*/v?(\d\S+)\.tar\.gz

## tzpfms 0.2.0

=== Makefile ===
--- 
+++ 
@@ -23,7 +23,7 @@
 include configMakefile
 
 
-LDDLLS := rt tspi $(OS_LD_LIBS)
+LDDLLS := rt tspi crypto
 PKGS := libzfs libzfs_core tss2-esys tss2-rc
 LDAR := $(LNCXXAR) $(foreach l,,-L$(BLDDIR)$(l)) $(foreach dll,$(LDDLLS),-l$(dll)) $(shell pkg-config --libs $(PKGS))
 INCAR := $(foreach l,$(foreach l,,$(l)/include),-isystemext/$(l)) $(foreach l,,-isystem$(BLDDIR)$(l)/include) $(shell pkg-config --cflags $(PKGS))
@@ -31,15 +31,23 @@
 BINARY_SOURCES := $(sort $(wildcard $(SRCDIR)bin/*.cpp $(SRCDIR)bin/**/*.cpp))
 COMMON_SOURCES := $(filter-out $(BINARY_SOURCES),$(sort $(wildcard $(SRCDIR)*.cpp $(SRCDIR)**/*.cpp $(SRCDIR)**/**/*.cpp $(SRCDIR)**/**/**/*.cpp)))
 MANPAGE_HEADERS := $(sort $(wildcard $(MANDIR)*.h))
-MANPAGE_SOURCES := $(sort $(wildcard $(MANDIR)*.md.pp))
+MANPAGE_SOURCES := $(sort $(wildcard $(MANDIR)*.[012345678].pp))
 INITRD_HEADERS := $(sort $(wildcard $(INITRDDIR)*.h))
 
+ifdef TZPFMS_PASSPHRASE_HELPER
+DEF_TPH := -DTZPFMS_PASSPHRASE_HELPER='$(TZPFMS_PASSPHRASE_HELPER)'
+endif
+ifdef TZPFMS_PASSPHRASE_HELPER_MAN
+DEF_TPH_MAN := .Pp\nDefault:\n.No '\'' Ns $(TZPFMS_PASSPHRASE_HELPER_MAN) Ns '\'' .
+else
+DEF_TPH_MAN ?= .
+endif
 
-.PHONY : all clean build shellcheck i-t dracut man
+.PHONY : all clean build shellcheck i-t dracut manpages htmlpages
 .SECONDARY:
 
 
-all : build man shellcheck i-t dracut
+all : build manpages htmlpages shellcheck i-t dracut
 
 shellcheck : i-t dracut
 	find $(OUTDIR)initramfs-tools/ $(OUTDIR)dracut -name '*.sh' -exec echo $(SHELLCHECK) --exclude SC1091 {} + | sh -x
@@ -47,17 +55,12 @@
 clean :
 	rm -rf $(OUTDIR)
 
-build : $(subst $(SRCDIR)bin/,$(OUTDIR),$(subst .cpp,$(EXE),$(BINARY_SOURCES)))
-man : $(OUTDIR)man/index.txt
+build : $(subst $(SRCDIR)bin/,$(OUTDIR),$(subst .cpp,,$(BINARY_SOURCES)))
+manpages : $(patsubst $(MANDIR)%.pp,$(OUTDIR)man/%,$(MANPAGE_SOURCES))
+htmlpages : $(patsubst $(MANDIR)%.pp,$(OUTDIR)man/%.html,$(MANPAGE_SOURCES)) $(OUTDIR)man/style.css
 i-t : $(OUTDIR)initramfs-tools/usr/share/initramfs-tools/hooks/tzpfms $(OUTDIR)initramfs-tools/usr/share/tzpfms/initramfs-tools-zfs-patch.sh
 dracut : $(patsubst $(INITRDDIR)dracut/%,$(OUTDIR)dracut/usr/lib/dracut/modules.d/91tzpfms/%,$(sort $(wildcard $(INITRDDIR)dracut/*.sh)))
 
-
-$(OUTDIR)man/index.txt : $(MANDIR)index.txt $(patsubst $(MANDIR)%.pp,$(OUTDIR)man/%,$(MANPAGE_SOURCES))
-	@mkdir -p $(dir $@)
-	cp $< $(dir $@)
-	$(RONN) --organization="tzpfms developers"    $(filter-out $<,$^)
-	$(RONN) --organization="tzpfms developers" -f $(filter-out $<,$^)
 
 $(OUTDIR)initramfs-tools/usr/share/initramfs-tools/hooks/tzpfms: $(INITRDDIR)initramfs-tools/hook $(INITRD_HEADERS)
 	@mkdir -p $(dir $@)
@@ -69,23 +72,35 @@
 	$(AWK) -f pp.awk $< > $@
 	chmod --reference $< $@
 
+# The d-v-o-s string starts at "BSD" (hence the "BSD General Commands Manual" default); we're not BSD, so hide it
+# Can't put it at the very top, since man(1) only loads mdoc *after* the first mdoc macro (.Dd in our case)
+$(OUTDIR)man/% : $(MANDIR)%.pp $(MANPAGE_HEADERS)
+	@mkdir -p $(dir $@)
+	$(AWK) -f pp.awk $< TZPFMS_PASSPHRASE_HELPER_MAN='$(DEF_TPH_MAN)' | $(AWK) '/^$$/ {prev_empty=1; next} $$1 == "#" && $$2 ~ /^[0-9]*$$/ {prev_empty=0; next}  {if(prev_empty) print ""; prev_empty=0; print}' | $(AWK) '$$0 == ".Dd" {$$2 = "$(TZPFMS_DATE)"}  $$1 == ".Dt" { print ".ds doc-volume-operating-system" }  $$0 == ".Os" {$$2 = "tzpfms"; $$3 = $(TZPFMS_VERSION)}  {print}' > $@
+	! $(MANDOC) -Tlint $@ 2>&1 | grep -vE -e 'mandoc: outdated mandoc.db' -e 'STYLE: referenced manual not found' -e 'STYLE: operating system explicitly specified: Os tzpfms' -e 'WARNING: cross reference to self: Xr zfs-tpm.*-change-key 8' -e 'STYLE: input text line longer than 80 bytes'
+# The "WARNING: unknown font, skipping request: TS.+fC[RBI]" one: see https://bugs.debian.org/992002
 
-$(OUTDIR)%$(EXE) : $(subst $(SRCDIR),$(OBJDIR),$(subst .cpp,$(OBJ),$(SRCDIR)bin/%.cpp $(COMMON_SOURCES)))
+$(OUTDIR)man/%.html : $(OUTDIR)man/%
 	@mkdir -p $(dir $@)
-	$(CXX) $(CXXAR) -o$@ $^ $(PIC) -Wl,--as-needed $(LDAR)
-	$(STRIP) $(STRIPAR) $@
+	( cd $(OUTDIR)man/ && $(MANDOC) -Thtml -Ostyle="style.css",man="%N.%S.html;https://manpages.debian.org/bullseye/%N.%S" ) < $< | \
+		$(AWK) '/^<h1/ {in_syn = $$0 ~ /id="SYNOPSIS"/}  /^<br/ {if(in_syn) next}  {print}' | \
+		$(SED) -Ee 's/ title=".."//g' -e 's/<a class="permalink" href="#([^"]*)"><span class="No" id="([^"]*)">/<a><span class="No">/g' -e 's#manpages.debian.org/[^/]*/ESYS_CONTEXT.3#mankier.com/3/ESYS_CONTEXT#g' > $@
 
-$(OBJDIR)%$(OBJ) : $(SRCDIR)%.cpp
+$(OUTDIR)man/style.css : man/style.css
 	@mkdir -p $(dir $@)
-	$(CXX) $(CXXAR) $(INCAR) $(VERAR) -c -o$@ $^
+	cp $^ $@
 
-$(BLDDIR)test/%$(OBJ) : $(TSTDIR)%.cpp
+$(BLDDIR)libtzpfms.a : $(subst $(SRCDIR),$(OBJDIR),$(subst .cpp,.o,$(COMMON_SOURCES)))
+	$(AR) crs $@ $^
+
+
+$(OUTDIR)% : $(OBJDIR)bin/%.o $(BLDDIR)libtzpfms.a
 	@mkdir -p $(dir $@)
-	$(CXX) $(CXXAR) $(INCAR) -I$(SRCDIR) $(VERAR) -c -o$@ $^
+	$(CXX) $(CXXAR) -Wl,--as-needed -o$@ $^ $(LDAR)
 
-$(OUTDIR)man/%.md : $(MANDIR)%.md.pp $(MANPAGE_HEADERS)
+$(OBJDIR)%.o : $(SRCDIR)%.cpp
 	@mkdir -p $(dir $@)
-	$(AWK) -f pp.awk $< > $@
+	$(CXX) $(CXXAR) $(INCAR) $(VERAR) $(DEF_TPH) -c -o$@ $^
 
 $(OUTDIR)dracut/usr/lib/dracut/modules.d/91tzpfms/% : $(INITRDDIR)dracut/% $(INITRD_HEADERS)
 	@mkdir -p $(dir $@)

=== debian/changelog ===
tzpfms (0.2.0-1) unstable; urgency=medium

  * Fix uscan filenamemangle
  * New upstream version 0.2.0
  * Add now-missing libssl-dev Build-Depends:
  * Note PCR binding in d/c Description:s
  * Update upstream changelog
  * Replace ronn instrumentation with mandoc
  * Use upstream-recommended systemd-ask-password integration
  * Refresh patches
  * Install README.md in all packages

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Mon, 29 Nov 2021 14:48:34 +0100

tzpfms (0.1.0-2) unstable; urgency=medium

  * Rebuild with 2.0.x-series libzfs dependencies

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Sat, 27 Mar 2021 19:32:22 +0100

=== debian/control ===
Source: tzpfms
Section: admin
Priority: optional
Maintainer: наб <nabijaczleweli@nabijaczleweli.xyz>
Standards-Version: 4.5.0
Rules-Requires-Root: no
Vcs-Git: https://git.sr.ht/~nabijaczleweli/tzpfms.deb
Vcs-Browser: https://git.sr.ht/~nabijaczleweli/tzpfms.deb
Homepage: https://sr.ht/~nabijaczleweli/tzpfms
Build-Depends: debhelper,
               debhelper-compat (= 13),
               shellcheck,
               mandoc,
               pkg-config,
               libzfslinux-dev,
               libtss2-dev,
               libtspi-dev,
               libssl-dev,

Package: tzpfms-tpm2
Recommends: tzpfms-common
Architecture: linux-any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Tag: implemented-in::c++, interface::commandline, role::program, scope::utility
Description: TPM-based encryption keys for ZFS datasets – TPM2 binaries
 tzpfms provides tooling to manage keys for encrypted ZFS datasets,
 with optional PCR binding and additional passwords, similarly to BitLocker.
 .
 This package contains the zfs-tpm2-{change,list,clear}-key binaries
 for managing keys backed by TPM2 devices.

Package: tzpfms-tpm1x
Recommends: tzpfms-common, trousers
Architecture: linux-any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Tag: implemented-in::c++, interface::commandline, role::program, scope::utility
Description: TPM-based encryption keys for ZFS datasets – TPM1.X binaries
 tzpfms provides tooling to manage keys for encrypted ZFS datasets,
 with optional PCR binding and additional passwords, similarly to BitLocker.
 .
 This package contains the zfs-tpm1x-{change,list,clear}-key binaries
 for managing keys backed by TPM1.X-backed TCS daemons.

Package: tzpfms-common
Architecture: linux-any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Tag: implemented-in::c++, interface::commandline, role::program, scope::utility
Description: TPM-based encryption keys for ZFS datasets – common binaries
 tzpfms provides tooling to manage keys for encrypted ZFS datasets,
 with optional PCR binding and additional passwords, similarly to BitLocker.
 .
 This package contains the zfs-tpm-list binary
 used for acquiring additional information about tzpfms-managed datasets.

Package: tzpfms-dracut
Suggests: tzpfms-tpm2, tzpfms-tpm1x
Architecture: all
Depends: ${misc:Depends},
         ${shlibs:Depends},
         tzpfms-common,
         zfs-dracut,
Tag: implemented-in::c++, admin::boot, interface::commandline, role::program,
 scope::utility
Description: TPM-based encryption keys for ZFS datasets – Dracut hooks
 tzpfms provides tooling to manage keys for encrypted ZFS datasets,
 with optional PCR binding and additional passwords, similarly to BitLocker.
 .
 This package contains Dracut hooks for booting with an encrypted ZFS rootfs
 backed by tzpfms.

Package: tzpfms-initramfs
Suggests: tzpfms-tpm2, tzpfms-tpm1x
Architecture: all
Depends: ${misc:Depends},
         ${shlibs:Depends},
         tzpfms-common,
         zfs-initramfs,
Tag: implemented-in::c++, admin::boot, interface::commandline, role::program,
 scope::utility
Description: TPM-based encryption keys for ZFS datasets – initramfs-tools hooks
 tzpfms provides tooling to manage keys for encrypted ZFS datasets,
 with optional PCR binding and additional passwords, similarly to BitLocker.
 .
 This package contains initramfs-tools hooks for booting
 with an encrypted ZFS rootfs backed by tzpfms.

=== debian/rules ===
#!/usr/bin/make -f


include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

CXX := $(CXX) $(subst -O2,,$(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get LDFLAGS))


override_dh_auto_build:
	$(MAKE) CXX="$(CXX)" TZPFMS_PASSPHRASE_HELPER='exec systemd-ask-password --id="tzpfms:$$$$2" "$$$$1:"' TZPFMS_PASSPHRASE_HELPER_MAN='Ic exec Nm systemd-ask-password Fl -id Ns Li = Ns Qo Li tzpfms:\& Ns Ar $$$$2 Qc Qo Ar $$$$1 Ns Li ":\&" Qc'

override_dh_installchangelogs:
	dh_installchangelogs debian/changelog.upstream

override_dh_installdocs:
	dh_installdocs -A $(wildcard TODO) README.md

%:
	dh $@

=== debian/watch ===
version=4
opts=filenamemangle=s/v?(\d\S+)\.tar\.gz/tzpfms-$1\.tar\.gz/ \
  https://git.sr.ht/~nabijaczleweli/tzpfms/refs .*/v?(\d\S+)\.tar\.gz

## tzpfms 0.3.0

=== debian/changelog ===
tzpfms (0.3.0-1~bpo11+1) bullseye; urgency=medium

  * Rebuild for bullseye.

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Mon, 20 Dec 2021 21:12:39 +0100

tzpfms (0.3.0-1) unstable; urgency=medium

  * Fix uscan filenamemangle
  * New upstream version 0.3.0
  * Update upstream changelog
  * Build-depend on systemd
  * Install systemd zfs-mount-generator intrgration to tzpfms-common
  * Replace patch with exporting TZPFMS_{VERSION,DATE} in d/rules
  * Fix TZPFMS_DATE day before the tenth

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Mon, 20 Dec 2021 20:29:15 +0100

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,9 @@
 export DEB_BUILD_MAINT_OPTIONS := hardening=+all
 
 CXX := $(CXX) $(subst -O2,,$(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get LDFLAGS))
+
+export TZPFMS_VERSION := "$(shell sed 's/^[^(]*(//;s/).*$$//;q' debian/changelog #))"
+export TZPFMS_DATE := $(shell awk '/^ -- / {sub(/^ -- .*>/, ""); sub(/^0/, "", $$2); print $$3 " " $$2 ", " $$4; exit}' debian/changelog | sed -E 's/Jan/&uary/;s/Feb/&ruary/;s/Mar/&ch/;s/Apr/&il/;s/Jun/&e/;s/Jul/&y/;s/Aug/&ust/;s/Sep/&tember/;s/Oct/&ober/;s/Nov|Dec/&ember/')
 
 
 override_dh_auto_build:

## tzpfms 0.3.1

=== Makefile ===
--- 
+++ 
@@ -43,14 +43,14 @@
 DEF_TPH_MAN ?= .
 endif
 
-.PHONY : all clean build shellcheck i-t dracut manpages htmlpages
+.PHONY : all clean build shellcheck i-t dracut init.d-systemd manpages htmlpages
 .SECONDARY:
 
 
-all : build manpages htmlpages shellcheck i-t dracut
+all : build manpages htmlpages shellcheck i-t init.d-systemd dracut
 
 shellcheck : i-t dracut
-	find $(OUTDIR)initramfs-tools/ $(OUTDIR)dracut -name '*.sh' -exec echo $(SHELLCHECK) --exclude SC1091 {} + | sh -x
+	find $(OUTDIR)initramfs-tools/ $(OUTDIR)dracut/ init.d/ -name '*.sh' -exec echo $(SHELLCHECK) --exclude SC1091,SC2093 {} + | sh -x
 
 clean :
 	rm -rf $(OUTDIR)
@@ -60,6 +60,7 @@
 htmlpages : $(patsubst $(MANDIR)%.pp,$(OUTDIR)man/%.html,$(MANPAGE_SOURCES)) $(OUTDIR)man/style.css
 i-t : $(OUTDIR)initramfs-tools/usr/share/initramfs-tools/hooks/tzpfms $(OUTDIR)initramfs-tools/usr/share/tzpfms/initramfs-tools-zfs-patch.sh
 dracut : $(patsubst $(INITRDDIR)dracut/%,$(OUTDIR)dracut/usr/lib/dracut/modules.d/91tzpfms/%,$(sort $(wildcard $(INITRDDIR)dracut/*.sh)))
+init.d-systemd : $(OUTDIR)systemd/$(SYSTEMD_SYSTEM_UNITDIR)/zfs-load-key@.service.d/tzpfms.conf $(OUTDIR)systemd/usr/libexec/tzpfms-zfs-load-key@
 
 
 $(OUTDIR)initramfs-tools/usr/share/initramfs-tools/hooks/tzpfms: $(INITRDDIR)initramfs-tools/hook $(INITRD_HEADERS)
@@ -71,6 +72,14 @@
 	@mkdir -p $(dir $@)
 	$(AWK) -f pp.awk $< > $@
 	chmod --reference $< $@
+
+$(OUTDIR)systemd/$(SYSTEMD_SYSTEM_UNITDIR)/zfs-load-key@.service.d/tzpfms.conf : init.d/systemd/zfs-load-key@.service.d-tzpfms.conf
+	@mkdir -p $(dir $@)
+	ln -f $< $@ || cp $< $@
+
+$(OUTDIR)systemd/usr/libexec/tzpfms-zfs-load-key@ : init.d/systemd/libexec-tzpfms-zfs-load-key@.sh
+	@mkdir -p $(dir $@)
+	ln -f $< $@ || cp $< $@
 
 # The d-v-o-s string starts at "BSD" (hence the "BSD General Commands Manual" default); we're not BSD, so hide it
 # Can't put it at the very top, since man(1) only loads mdoc *after* the first mdoc macro (.Dd in our case)

=== debian/changelog ===
tzpfms (0.3.1-1~bpo11) bullseye; urgency=medium

  * Rebuild for bullseye.

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Sat, 29 Oct 2022 23:34:51 +0200

tzpfms (0.3.1-1) unstable; urgency=medium

  * New upstream version 0.3.1
  * Import upstream changelog
  * Only build documentation and depend on mandoc if !nodoc
  * Only (depend on) shellcheck if !nocheck

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Sat, 29 Oct 2022 23:28:58 +0200

=== debian/control ===
--- 
+++ 
@@ -9,13 +9,14 @@
 Homepage: https://sr.ht/~nabijaczleweli/tzpfms
 Build-Depends: debhelper,
                debhelper-compat (= 13),
-               shellcheck,
-               mandoc,
+               shellcheck <!nocheck>,
+               mandoc <!nodoc>,
                pkg-config,
                libzfslinux-dev,
                libtss2-dev,
                libtspi-dev,
                libssl-dev,
+               systemd,
 
 Package: tzpfms-tpm2
 Recommends: tzpfms-common

## tzpfms 0.3.2

=== debian/changelog ===
tzpfms (0.3.2-1~bpo11) bullseye; urgency=medium

  * Rebuild for bullseye.

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Sun, 04 Dec 2022 14:46:22 +0100

tzpfms (0.3.2-1) unstable; urgency=medium

  * New upstream version 0.3.2
  * Update upstream changelog

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Sun, 04 Dec 2022 14:30:51 +0100

=== debian/rules ===
#!/usr/bin/make -f


include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

CXX := $(CXX) $(subst -O2,,$(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get LDFLAGS))

export TZPFMS_VERSION := "$(shell sed 's/^[^(]*(//;s/).*$$//;q' debian/changelog #))"
export TZPFMS_DATE := $(shell awk '/^ -- / {sub(/^ -- .*>/, ""); sub(/^0/, "", $$2); print $$3 " " $$2 ", " $$4; exit}' debian/changelog | sed -E 's/Jan/&uary/;s/Feb/&ruary/;s/Mar/&ch/;s/Apr/&il/;s/Jun/&e/;s/Jul/&y/;s/Aug/&ust/;s/Sep/&tember/;s/Oct/&ober/;s/Nov|Dec/&ember/')

targets := $(shell sed -n '/^all :/s///p' Makefile)
ifneq "$(filter nocheck,$(DEB_BUILD_PROFILES))" ""
targets := $(filter-out shellcheck,$(targets))
endif
ifneq "$(filter nodoc,$(DEB_BUILD_PROFILES))" ""
targets := $(filter-out %pages,$(targets))
endif


override_dh_auto_build:
	$(MAKE) $(targets) CXX="$(CXX)" TZPFMS_PASSPHRASE_HELPER='exec systemd-ask-password --id="tzpfms:$$$$2" "$$$$1:"' TZPFMS_PASSPHRASE_HELPER_MAN='Ic exec Nm systemd-ask-password Fl -id Ns Li = Ns Qo Li tzpfms:\& Ns Ar $$$$2 Qc Qo Ar $$$$1 Ns Li ":\&" Qc'

override_dh_installchangelogs:
	dh_installchangelogs debian/changelog.upstream

override_dh_installdocs:
ifeq "$(filter nodoc,$(DEB_BUILD_PROFILES))" ""
	dh_installdocs -A $(wildcard TODO) README.md
endif

%:
	dh $@

## tzpfms 0.3.3

=== debian/changelog ===
tzpfms (0.3.3-1) unstable; urgency=medium

  * New upstream version 0.3.3
  * Update upstream changelog

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Mon, 12 Jun 2023 19:42:45 +0200

## tzpfms 0.3.4

=== Makefile ===
# SPDX-License-Identifier: MIT


-include Makefile.local


TZPFMS_VERSION ?= "$(patsubst v%,%,$(shell git describe))"
SOURCE_DATE_EPOCH ?=
TZPFMS_DATE ?=


AWK ?= awk
SED ?= sed
MANDOC ?= mandoc
PKGCONF ?= pkgconf
SHELLCHECK ?= shellcheck

NOLOCREGEN ?=
OUTDIR := out/
BLDDIR := out/build/

SYSTEMD_SYSTEM_UNITDIR := $(shell $(PKGCONF) --variable=systemd_system_unit_dir systemd 2>/dev/null || echo /usr/lib/systemd/system)
ifneq "$(TZPFMS_DATE)" ""
MANUAL_DATE := $(TZPFMS_DATE)
else ifneq "$(SOURCE_DATE_EPOCH)" ""
MANUAL_DATE := $(shell LC_ALL=C date -d@$(SOURCE_DATE_EPOCH) '+%B %e, %Y')
else
MANUAL_DATE  = $(shell LC_ALL=C date -d@$(shell git log -1 --no-show-signature --format=%at $(1)) '+%B %e, %Y')
endif


PKGS := libzfs libzfs_core tss2-esys tss2-rc
PKGCONF_LIBS   := $(shell pkg-config --libs   $(PKGS))
PKGCONF_CFLAGS := $(shell pkg-config --cflags $(PKGS))

LDFLAGS  += -Wl,--as-needed
LDLIBS   += -lrt -ltspi -lcrypto $(PKGCONF_LIBS)
CXXFLAGS += -g -O3 -std=c++17 -fno-exceptions -fno-rtti -Wall -Wextra -pipe -fPIC $(PKGCONF_CFLAGS)
CPPFLAGS += -MD -DTZPFMS_VERSION='$(TZPFMS_VERSION)'
BINARY_SOURCES := $(sort $(wildcard src/bin/*.cpp src/bin/**/*.cpp))
COMMON_SOURCES := $(filter-out $(BINARY_SOURCES),$(sort $(wildcard src/*.cpp src/**/*.cpp src/**/**/*.cpp src/**/**/**/*.cpp)))
MANPAGE_HEADERS := $(sort $(wildcard man/*.h))
MANPAGE_SOURCES := $(sort $(wildcard man/*.[0-8].pp))
INITRD_HEADERS := $(sort $(wildcard initrd/*.h))
ifneq (,$(shell command -v msgfmt))
	LOCALES := $(wildcard po/*.po)
endif


ifdef TZPFMS_PASSPHRASE_HELPER
CPPFLAGS += -DTZPFMS_PASSPHRASE_HELPER='$(TZPFMS_PASSPHRASE_HELPER)'
endif
ifdef TZPFMS_PASSPHRASE_HELPER_MAN
DEF_TPH_MAN := .Pp\nDefault:\n.No '\'' Ns $(TZPFMS_PASSPHRASE_HELPER_MAN) Ns '\'' .
else
DEF_TPH_MAN ?= .
endif


ifneq "$(findstring clang,$(shell $(CXX) --version))" ""
	# GCC doesn't have this granularity
	CXXFLAGS += -flto=full -pedantic -Wno-gnu-statement-expression -Wno-gnu-include-next -Wno-gnu-conditional-omitted-operand -Wno-c++20-designator
	ifeq "$(AR)" "ar"
		# Need this because -flto=full produces objects FSF ranlib (ar s) can't index
		override AR := llvm-ar
	endif
else
	CXXFLAGS += -flto
endif



.PHONY : all locales clean build shellcheck i-t dracut init.d-systemd manpages htmlpages
.SECONDARY :


all : build locales manpages htmlpages shellcheck i-t init.d-systemd dracut

shellcheck : i-t dracut
	find $(OUTDIR)initramfs-tools/ $(OUTDIR)dracut/ init.d/ -name '*.sh' -exec echo $(SHELLCHECK) --exclude SC1091,SC2093 {} + | sh -x

clean :
	rm -rf $(OUTDIR)

build : $(subst src/bin/,$(OUTDIR),$(subst .cpp,,$(BINARY_SOURCES)))
manpages : $(patsubst man/%.pp,$(OUTDIR)man/%,$(MANPAGE_SOURCES))
htmlpages : $(patsubst man/%.pp,$(OUTDIR)man/%.html,$(MANPAGE_SOURCES)) $(OUTDIR)man/style.css
locales : $(patsubst po/%.po,$(OUTDIR)locale/%/LC_MESSAGES/tzpfms.mo,$(LOCALES))
i-t : $(OUTDIR)initramfs-tools/usr/share/initramfs-tools/hooks/tzpfms $(OUTDIR)initramfs-tools/usr/share/tzpfms/initramfs-tools-zfs-patch.sh
dracut : $(patsubst initrd/dracut/%,$(OUTDIR)dracut/usr/lib/dracut/modules.d/91tzpfms/%,$(sort $(wildcard initrd/dracut/*.sh)))
init.d-systemd : $(OUTDIR)systemd/$(SYSTEMD_SYSTEM_UNITDIR)/zfs-load-key@.service.d/tzpfms.conf $(OUTDIR)systemd/usr/libexec/tzpfms-zfs-load-key@


$(BLDDIR)tzpfms.pot: src/*.[ch]pp src/bin/*.[ch]pp
	@mkdir -p $(@D)
	$(NOLOCREGEN)xgettext --check=ellipsis-unicode --from-code=UTF-8 -c -io- $^ | sed -n '/^#[:.]/,$$p' > $@
	$(NOLOCREGEN)$(foreach l,$(LOCALES),msgmerge --backup=off --no-wrap -Uiq $(l) $@ &&) :
	@>> $@

$(OUTDIR)locale/%/LC_MESSAGES/tzpfms.mo : po/%.po $(BLDDIR)tzpfms.pot
	@mkdir -p $(@D)
	msgfmt --statistics --check-format --check-domain -o $@ $<


$(OUTDIR)initramfs-tools/usr/share/initramfs-tools/hooks/tzpfms: initrd/initramfs-tools/hook $(INITRD_HEADERS)
	@mkdir -p $(dir $@)
	$(AWK) -f pp.awk $< > $@
	chmod --reference $< $@

$(OUTDIR)initramfs-tools/usr/share/tzpfms/initramfs-tools-zfs-patch.sh: initrd/initramfs-tools/zfs-patch.sh $(INITRD_HEADERS)
	@mkdir -p $(dir $@)
	$(AWK) -f pp.awk $< > $@
	chmod --reference $< $@

$(OUTDIR)systemd/$(SYSTEMD_SYSTEM_UNITDIR)/zfs-load-key@.service.d/tzpfms.conf : init.d/systemd/zfs-load-key@.service.d-tzpfms.conf
	@mkdir -p $(dir $@)
	ln -f $< $@ || cp $< $@

$(OUTDIR)systemd/usr/libexec/tzpfms-zfs-load-key@ : init.d/systemd/libexec-tzpfms-zfs-load-key@.sh
	@mkdir -p $(dir $@)
	ln -f $< $@ || cp $< $@

# The d-v-o-s string starts at "BSD" (hence the "BSD General Commands Manual" default); we're not BSD, so hide it
# Can't put it at the very top, since man(1) only loads mdoc *after* the first mdoc macro (.Dd in our case)
$(OUTDIR)man/% : man/%.pp $(MANPAGE_HEADERS)
	@mkdir -p $(dir $@)
	$(AWK) -f pp.awk $< TZPFMS_PASSPHRASE_HELPER_MAN='$(DEF_TPH_MAN)' | $(AWK) '/^$$/ {prev_empty=1; next} $$1 == "#" && $$2 ~ /^[0-9]*$$/ {prev_empty=0; next}  {if(prev_empty) print ""; prev_empty=0; print}' | $(AWK) '$$0 == ".Dd" {$$2 = "$(call MANUAL_DATE,$<)"}  $$1 == ".Dt" { print ".ds doc-volume-operating-system" }  $$0 == ".Os" {$$2 = "tzpfms"; $$3 = $(TZPFMS_VERSION)}  {print}' > $@
	! $(MANDOC) -Tlint $@ 2>&1 | grep -vE -e 'mandoc: outdated mandoc.db' -e 'STYLE: referenced manual not found' -e 'STYLE: operating system explicitly specified: Os tzpfms' -e 'WARNING: cross reference to self: Xr zfs-tpm.*-change-key 8' -e 'STYLE: input text line longer than 80 bytes'
# The "WARNING: unknown font, skipping request: TS.+fC[RBI]" one: see https://bugs.debian.org/992002

$(OUTDIR)man/%.html : $(OUTDIR)man/%
	@mkdir -p $(dir $@)
	( cd $(OUTDIR)man/ && $(MANDOC) -Thtml -Ostyle="style.css",man="%N.%S.html;https://manpages.debian.org/bookworm/%N.%S" ) < $< | \
		$(AWK) '/^<h1/ {in_syn = $$0 ~ /id="SYNOPSIS"/}  /^<br/ {if(in_syn) next}  {print}' | \
		$(SED) -Ee 's/ title=".."//g' -e 's/<a class="permalink" href="#([^"]*)"><span class="No" id="([^"]*)">/<a><span class="No">/g' -e 's#manpages.debian.org/[^/]*/ESYS_CONTEXT.3#mankier.com/3/ESYS_CONTEXT#g' > $@

$(OUTDIR)man/style.css : man/style.css
	@mkdir -p $(dir $@)
	cp $^ $@

$(BLDDIR)libtzpfms.a : $(subst src/,$(BLDDIR)obj/,$(subst .cpp,.o,$(COMMON_SOURCES)))
	$(AR) crs $@ $^


$(OUTDIR)% : $(BLDDIR)obj/bin/%.o $(BLDDIR)libtzpfms.a
	@mkdir -p $(dir $@)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $@ $^ $(LDLIBS)

$(BLDDIR)obj/%.o : src/%.cpp
	@mkdir -p $(dir $@)
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -c -o $@ $<

$(OUTDIR)dracut/usr/lib/dracut/modules.d/91tzpfms/% : initrd/dracut/% $(INITRD_HEADERS)
	@mkdir -p $(dir $@)
	$(AWK) -f pp.awk $< > $@
	chmod --reference $< $@


include $(wildcard $(BLDDIR)*/*.d $(BLDDIR)*/*/*.d)

=== debian/changelog ===
tzpfms (0.3.4-1) unstable; urgency=medium

  * Add d/upstream/signing-key.asc and update d/watch to find the signature
  * New upstream version 0.3.4 (+ changelog & NEWS)
    => install locales
  * Add d/upstream/metadata
  * d/copyright: update with new upstream licensing
  * Drop shellcheck

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Wed, 06 Dec 2023 02:50:31 +0100

=== debian/control ===
--- 
+++ 
@@ -2,14 +2,13 @@
 Section: admin
 Priority: optional
 Maintainer: наб <nabijaczleweli@nabijaczleweli.xyz>
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Git: https://git.sr.ht/~nabijaczleweli/tzpfms.deb
 Vcs-Browser: https://git.sr.ht/~nabijaczleweli/tzpfms.deb
 Homepage: https://sr.ht/~nabijaczleweli/tzpfms
 Build-Depends: debhelper,
                debhelper-compat (= 13),
-               shellcheck <!nocheck>,
                mandoc <!nodoc>,
                pkg-config,
                libzfslinux-dev,

=== debian/rules ===
#!/usr/bin/make -f


export DEB_BUILD_MAINT_OPTIONS := hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export TZPFMS_VERSION := "$(shell IFS="$$IFS()" read -r _ v _ < debian/changelog && echo "$$v")"
export TZ := UTC0
export NOLOCREGEN := @\#

targets := $(filter-out htmlpages shellcheck,$(shell sed -n '/^all :/s///p' Makefile))
ifneq "$(filter nodoc,$(DEB_BUILD_PROFILES))" ""
targets := $(filter-out %pages,$(targets))
endif


override_dh_auto_build:
	$(MAKE) $(targets) TZPFMS_PASSPHRASE_HELPER='exec systemd-ask-password --id="tzpfms:$$$$2" "$$$$1:"' TZPFMS_PASSPHRASE_HELPER_MAN='Ic exec Nm systemd-ask-password Fl -id Ns Li = Ns Qo Li tzpfms:\& Ns Ar $$$$2 Qc Qo Ar $$$$1 Ns Li ":\&" Qc'

override_dh_installchangelogs:
	dh_installchangelogs debian/changelog.upstream

override_dh_installdocs:
	dh_installdocs -A README.md
	cp debian/NEWS.upstream debian/tzpfms-common/usr/share/doc/tzpfms-common/NEWS

%:
	dh $@

## tzpfms 0.4.0

=== debian/changelog ===
tzpfms (0.4.0-1+bpo12~1) bookworm; urgency=medium

  * Rebuild for bookworm.

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Fri, 29 Mar 2024 20:48:29 +0100

tzpfms (0.4.0-1) unstable; urgency=medium

  * Pass dpkg-buildpackage's -j to make
  * d/control: Build-Depends: systemd-dev | systemd (we just want pkgconf)
  * d/control: Tag
  * Run on CI
  * New upstream version 0.4.0 (+ changelog & NEWS)
  * Build-Depend on gettext unless pkg.tzpfms.noloc

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Fri, 29 Mar 2024 13:38:44 +0100

=== debian/watch ===
version=4
opts="filenamemangle=s/.*\/v?(\d\S+)\.tar\.gz/tzpfms-$1\.tar\.gz/, pgpsigurlmangle=s/$/.asc/" \
  https://git.sr.ht/~nabijaczleweli/tzpfms/refs .*/v?(\d\S+)\.tar\.gz

## tzpfms 0.4.1

=== Makefile ===
--- 
+++ 
@@ -12,14 +12,14 @@
 AWK ?= awk
 SED ?= sed
 MANDOC ?= mandoc
-PKGCONF ?= pkgconf
+PKG_CONFIG ?= pkgconf
 SHELLCHECK ?= shellcheck
 
 NOLOCREGEN ?=
 OUTDIR := out/
 BLDDIR := out/build/
 
-SYSTEMD_SYSTEM_UNITDIR := $(shell $(PKGCONF) --variable=systemd_system_unit_dir systemd 2>/dev/null || echo /usr/lib/systemd/system)
+SYSTEMD_SYSTEM_UNITDIR := $(shell $(PKG_CONFIG) --variable=systemd_system_unit_dir systemd 2>/dev/null || echo /usr/lib/systemd/system)
 ifneq "$(TZPFMS_DATE)" ""
 MANUAL_DATE := $(TZPFMS_DATE)
 else ifneq "$(SOURCE_DATE_EPOCH)" ""
@@ -30,12 +30,12 @@
 
 
 PKGS := libzfs libzfs_core tss2-esys tss2-rc
-PKGCONF_LIBS   := $(shell pkg-config --libs   $(PKGS))
-PKGCONF_CFLAGS := $(shell pkg-config --cflags $(PKGS))
+PKG_CONFIG_LIBS   := $(shell $(PKG_CONFIG) --libs   $(PKGS))
+PKG_CONFIG_CFLAGS := $(shell $(PKG_CONFIG) --cflags $(PKGS))
 
 LDFLAGS  += -Wl,--as-needed
-LDLIBS   += -lrt -ltspi -lcrypto $(PKGCONF_LIBS)
-CXXFLAGS += -g -O3 -std=c++17 -fno-exceptions -fno-rtti -Wall -Wextra -pipe -fPIC $(PKGCONF_CFLAGS)
+LDLIBS   += -lrt -ltspi -lcrypto $(PKG_CONFIG_LIBS)
+CXXFLAGS += -g -O3 -std=c++17 -fno-exceptions -fno-rtti -Wall -Wextra -pipe -fPIC $(PKG_CONFIG_CFLAGS)
 CPPFLAGS += -MD -DTZPFMS_VERSION='$(TZPFMS_VERSION)'
 BINARY_SOURCES := $(sort $(wildcard src/bin/*.cpp src/bin/**/*.cpp))
 COMMON_SOURCES := $(filter-out $(BINARY_SOURCES),$(sort $(wildcard src/*.cpp src/**/*.cpp src/**/**/*.cpp src/**/**/**/*.cpp)))
@@ -59,7 +59,7 @@
 
 ifneq "$(findstring clang,$(shell $(CXX) --version))" ""
 	# GCC doesn't have this granularity
-	CXXFLAGS += -flto=full -pedantic -Wno-gnu-statement-expression -Wno-gnu-include-next -Wno-gnu-conditional-omitted-operand -Wno-c++20-designator
+	CXXFLAGS += -flto=full -pedantic -Wno-gnu-statement-expression -Wno-gnu-include-next -Wno-gnu-conditional-omitted-operand -Wno-c++20-designator -Wno-variadic-macros -Wno-c99-extensions
 	ifeq "$(AR)" "ar"
 		# Need this because -flto=full produces objects FSF ranlib (ar s) can't index
 		override AR := llvm-ar
@@ -77,7 +77,7 @@
 all : build locales manpages htmlpages shellcheck i-t init.d-systemd dracut
 
 shellcheck : i-t dracut
-	find $(OUTDIR)initramfs-tools/ $(OUTDIR)dracut/ init.d/ -name '*.sh' -exec echo $(SHELLCHECK) --exclude SC1091,SC2093 {} + | sh -x
+	$(SHELLCHECK) --exclude SC1091,SC2093 $(foreach l,$(OUTDIR)initramfs-tools/ $(OUTDIR)dracut/ init.d/,$(wildcard $(l)*.sh $(l)**/*.sh $(l)**/**/*.sh $(l)**/**/**/*.sh $(l)**/**/**/**/*.sh $(l)**/**/**/**/**/*.sh $(l)**/**/**/**/**/**/*.sh $(l)**/**/**/**/**/**/**/*.sh $(l)**/**/**/**/**/**/**/**/*.sh))
 
 clean :
 	rm -rf $(OUTDIR)
@@ -88,7 +88,7 @@
 locales : $(patsubst po/%.po,$(OUTDIR)locale/%/LC_MESSAGES/tzpfms.mo,$(LOCALES))
 i-t : $(OUTDIR)initramfs-tools/usr/share/initramfs-tools/hooks/tzpfms $(OUTDIR)initramfs-tools/usr/share/tzpfms/initramfs-tools-zfs-patch.sh
 dracut : $(patsubst initrd/dracut/%,$(OUTDIR)dracut/usr/lib/dracut/modules.d/91tzpfms/%,$(sort $(wildcard initrd/dracut/*.sh)))
-init.d-systemd : $(OUTDIR)systemd/$(SYSTEMD_SYSTEM_UNITDIR)/zfs-load-key@.service.d/tzpfms.conf $(OUTDIR)systemd/usr/libexec/tzpfms-zfs-load-key@
+init.d-systemd : $(OUTDIR)systemd/$(SYSTEMD_SYSTEM_UNITDIR)/zfs-load-key@.service.d/tzpfms.conf $(OUTDIR)systemd/usr/libexec/tzpfms-zfs-load-key@ $(foreach l,$(subst init.d/systemd/usr-share-tzpfms/,,$(wildcard init.d/systemd/usr-share-tzpfms/*)),$(OUTDIR)systemd/usr/share/tzpfms/$(l))
 
 
 $(BLDDIR)tzpfms.pot: src/*.[ch]pp src/bin/*.[ch]pp
@@ -120,6 +120,10 @@
 	@mkdir -p $(dir $@)
 	ln -f $< $@ || cp $< $@
 
+$(OUTDIR)systemd/usr/share/tzpfms/% : init.d/systemd/usr-share-tzpfms/%
+	@mkdir -p $(dir $@)
+	ln -f $< $@ || cp $< $@
+
 # The d-v-o-s string starts at "BSD" (hence the "BSD General Commands Manual" default); we're not BSD, so hide it
 # Can't put it at the very top, since man(1) only loads mdoc *after* the first mdoc macro (.Dd in our case)
 $(OUTDIR)man/% : man/%.pp $(MANPAGE_HEADERS)
@@ -139,7 +143,7 @@
 	cp $^ $@
 
 $(BLDDIR)libtzpfms.a : $(subst src/,$(BLDDIR)obj/,$(subst .cpp,.o,$(COMMON_SOURCES)))
-	$(AR) crs $@ $^
+	$(AR) --thin crs $@ $^
 
 
 $(OUTDIR)% : $(BLDDIR)obj/bin/%.o $(BLDDIR)libtzpfms.a

=== debian/changelog ===
tzpfms (0.4.1-1) unstable; urgency=medium

  * New upstream version 0.4.1 (+ changelog & NEWS)

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Sun, 09 Mar 2025 17:24:20 +0100

=== debian/control ===
--- 
+++ 
@@ -15,14 +15,15 @@
                libtss2-dev,
                libtspi-dev,
                libssl-dev,
-               systemd,
+               systemd-dev | systemd,
+               gettext <!pkg.tzpfms.noloc>,
 
 Package: tzpfms-tpm2
 Recommends: tzpfms-common
 Architecture: linux-any
 Depends: ${misc:Depends},
          ${shlibs:Depends},
-Tag: implemented-in::c++, interface::commandline, role::program, scope::utility
+#Tag: admin::filesystem, implemented-in::c++, interface::commandline, role::program, scope::utility, use::configuring
 Description: TPM-based encryption keys for ZFS datasets – TPM2 binaries
  tzpfms provides tooling to manage keys for encrypted ZFS datasets,
  with optional PCR binding and additional passwords, similarly to BitLocker.
@@ -35,7 +36,7 @@
 Architecture: linux-any
 Depends: ${misc:Depends},
          ${shlibs:Depends},
-Tag: implemented-in::c++, interface::commandline, role::program, scope::utility
+#Tag: admin::filesystem, implemented-in::c++, interface::commandline, role::program, scope::utility, use::configuring
 Description: TPM-based encryption keys for ZFS datasets – TPM1.X binaries
  tzpfms provides tooling to manage keys for encrypted ZFS datasets,
  with optional PCR binding and additional passwords, similarly to BitLocker.
@@ -47,7 +48,7 @@
 Architecture: linux-any
 Depends: ${misc:Depends},
          ${shlibs:Depends},
-Tag: implemented-in::c++, interface::commandline, role::program, scope::utility
+#Tag: admin::filesystem, implemented-in::c++, implemented-in::shell, interface::commandline, role::program, scope::utility, use::configuring
 Description: TPM-based encryption keys for ZFS datasets – common binaries
  tzpfms provides tooling to manage keys for encrypted ZFS datasets,
  with optional PCR binding and additional passwords, similarly to BitLocker.
@@ -62,8 +63,7 @@
          ${shlibs:Depends},
          tzpfms-common,
          zfs-dracut,
-Tag: implemented-in::c++, admin::boot, interface::commandline, role::program,
- scope::utility
+#Tag: admin::filesystem, admin::boot, implemented-in::shell, role::plugin
 Description: TPM-based encryption keys for ZFS datasets – Dracut hooks
  tzpfms provides tooling to manage keys for encrypted ZFS datasets,
  with optional PCR binding and additional passwords, similarly to BitLocker.
@@ -78,8 +78,7 @@
          ${shlibs:Depends},
          tzpfms-common,
          zfs-initramfs,
-Tag: implemented-in::c++, admin::boot, interface::commandline, role::program,
- scope::utility
+#Tag: admin::filesystem, admin::boot, implemented-in::shell, role::plugin
 Description: TPM-based encryption keys for ZFS datasets – initramfs-tools hooks
  tzpfms provides tooling to manage keys for encrypted ZFS datasets,
  with optional PCR binding and additional passwords, similarly to BitLocker.

=== debian/rules ===
--- 
+++ 
@@ -16,7 +16,7 @@
 
 
 override_dh_auto_build:
-	$(MAKE) $(targets) TZPFMS_PASSPHRASE_HELPER='exec systemd-ask-password --id="tzpfms:$$$$2" "$$$$1:"' TZPFMS_PASSPHRASE_HELPER_MAN='Ic exec Nm systemd-ask-password Fl -id Ns Li = Ns Qo Li tzpfms:\& Ns Ar $$$$2 Qc Qo Ar $$$$1 Ns Li ":\&" Qc'
+	dh_auto_build -- $(targets) TZPFMS_PASSPHRASE_HELPER='exec systemd-ask-password --id="tzpfms:$$$$2" "$$$$1:"' TZPFMS_PASSPHRASE_HELPER_MAN='Ic exec Nm systemd-ask-password Fl -id Ns Li = Ns Qo Li tzpfms:\& Ns Ar $$$$2 Qc Qo Ar $$$$1 Ns Li ":\&" Qc'
 
 override_dh_installchangelogs:
 	dh_installchangelogs debian/changelog.upstream
